diff -ruN freeswan-1.5.orig/pluto/ipsec_doi.c freeswan-1.5/pluto/ipsec_doi.c
--- freeswan-1.5.orig/pluto/ipsec_doi.c	Wed Jun 21 14:24:32 2000
+++ freeswan-1.5/pluto/ipsec_doi.c	Thu Oct  5 07:05:59 2000
@@ -47,6 +47,10 @@
 #include "md5.h"
 #include "crypto.h" /* requires sha1.h and md5.h */
 
+#ifdef OPENSSL
+#include "openssl.h"
+#endif
+
 /* MAGIC: perform f, a function that returns notification_t
  * and return from the ENCLOSING stf_status returning function if it fails.
  */
@@ -56,6 +60,65 @@
 /* if we haven't already done so, compute a local DH secret (st->st_sec) and
  * the corresponding public value (g).  This is emitted as a KE payload.
  */
+#ifdef OPENSSL
+static bool
+build_and_ship_KE_rpk(struct state *st, bool init,
+		      chunk_t *g,
+		      const struct oakley_group_desc *group, pb_stream *outs,
+		      u_int8_t np)
+{
+  keysched *ks;
+  u_char *iv;
+  chunk_t op;
+  bool res;
+
+    if (!st->st_sec_in_use)
+    {
+	u_char tmp[LOCALSECRETSIZE];
+	MP_INT mp_g;
+
+	get_rnd_bytes(tmp, LOCALSECRETSIZE);
+	st->st_sec_in_use = TRUE;
+	n_to_mpz(&st->st_sec, tmp, LOCALSECRETSIZE);
+
+	mpz_init(&mp_g);
+	mpz_powm(&mp_g, &groupgenerator, &st->st_sec, group->modulus);
+	*g = mpz_to_n(&mp_g, group->bytes);
+	mpz_clear(&mp_g);
+#ifdef DODGE_DH_MISSING_ZERO_BUG
+	if (g->ptr[0] == 0)
+	{
+	    /* generate a new secret to avoid this situation */
+	    log("regenerating DH private secret to avoid Pluto 1.0 bug"
+		" handling public value with leading zero");
+	    mpz_clear(&st->st_sec);
+	    st->st_sec_in_use = FALSE;
+	    freeanychunk(*g);
+	    return build_and_ship_KE_rpk(st, init, g, group, outs, np);
+	}
+#endif
+
+	DBG(DBG_CRYPT,
+	    DBG_dump("Local DH secret:\n", tmp, LOCALSECRETSIZE);
+	    DBG_dump_chunk("Public DH value sent:\n", *g));
+    }
+    /* Encrypt the chunk */
+    if (init) {
+      ks = &st->st_ks_i;
+      iv = st->st_ne_i_iv;
+    } else {
+      ks = &st->st_ks_r;
+      iv = st->st_ne_r_iv;
+    }
+    setchunk(op, NULL, 0);
+    if (!encrypt_payload( st, ks, iv, *g, &op )) return FALSE;
+    res = out_generic_chunk(np, &isakmp_keyex_desc, outs, op,
+			    "encrypted keyex value");
+    freeanychunk(op);
+    return res;
+}
+#endif
+
 static bool
 build_and_ship_KE(struct state *st, chunk_t *g
     , const struct oakley_group_desc *group, pb_stream *outs, u_int8_t np)
@@ -192,6 +255,21 @@
     return out_generic_chunk(np, &isakmp_nonce_desc, outs, *n, name);
 }
 
+#ifdef OPENSSL
+static bool
+build_and_ship_nonce_pk(struct state *st, chunk_t *n, pb_stream *outs, u_int8_t np, const char *name)
+{
+    chunk_t c;
+
+    setchunk(*n, alloc_bytes(DEFAULT_NONCE_SIZE, name), DEFAULT_NONCE_SIZE);
+    get_rnd_bytes(n->ptr, DEFAULT_NONCE_SIZE);
+    c.len = n->len;
+    c.ptr = clone_bytes(n->ptr, c.len, name);
+    pubkey_encrypt_chunk(&c, st);
+    return out_generic_chunk(np, &isakmp_nonce_desc, outs, c, name);
+}
+#endif
+
 /*
  * Send a notification to the peer. We could make a decision on
  * whether to send the notification, based on the type and the
@@ -290,6 +368,9 @@
 
     struct state *st;
 
+	DBG(DBG_PARSING,
+	    DBG_log("in main_outI1");
+	);
     /* set up new state */
     cur_state = st = new_state();
     st->st_connection = c;
@@ -347,7 +428,11 @@
 
 	    if (get_RSA_private_key(c) != NULL
 	    && get_RSA_public_key(&c->that.id) != NULL)
+#ifndef OPENSSL
 		auth_policy |= POLICY_RSASIG;
+#else
+		auth_policy |= POLICY_OPENSSL;
+#endif
 	    /* Not clear what we should do if neither is possible.
 	     * Perhaps we should not have entered negotiations at all.
 	     */
@@ -358,6 +443,23 @@
 		return STF_INTERNAL_ERROR;
 	    }
 	}
+
+#ifdef OPENSSL
+if (use_openssl(c)) 
+{
+	loglog(RC_LOG_SERIOUS, "Using OPENSSL sadb.");
+	if (!out_sa(&rbody
+	, &oakley_sadb2[auth_policy >> POLICY_ISAKMP_SHIFT]
+	, st, TRUE, ISAKMP_NEXT_NONE))
+	{
+	    cur_state = NULL;
+	    return STF_INTERNAL_ERROR;
+	}
+}
+else
+{
+#endif /* OPENSSL */
+	loglog(RC_LOG_SERIOUS, "Using standard sadb.");
 	if (!out_sa(&rbody
 	, &oakley_sadb[auth_policy >> POLICY_ISAKMP_SHIFT]
 	, st, TRUE, ISAKMP_NEXT_NONE))
@@ -365,6 +467,10 @@
 	    cur_state = NULL;
 	    return STF_INTERNAL_ERROR;
 	}
+#ifdef OPENSSL
+}
+#endif /* ! OPENSSL */
+
 
 	/* save initiator SA for later HASH */
 	passert(st->st_p1isa.ptr == NULL);	/* no leak!  (MUST be first time) */
@@ -517,6 +623,70 @@
     hmac_final_chunk(st->st_skeyid, "st_skeyid in skeyid_digisig()", &ctx);
     return TRUE;
 }
+// static bool
+// skeyid_digisig(struct state *st)
+// {
+//     struct hmac_ctx ctx;
+//     const chunk_t cat = chunk_concat( st->st_ni, st->st_nr );
+// 
+//     hmac_init_chunk(&ctx, st->st_oakley.hasher, cat);
+//     hmac_update_chunk(&ctx, st->st_shared);
+//     hmac_final_chunk(st->st_skeyid, "st_skeyid in skeyid_digisig()", &ctx);
+//     memset(cat.ptr, 0, cat.len);
+//     free(cat.ptr);
+//     return TRUE;
+// }
+
+#ifdef OPENSSL
+// static const chunk_t
+// chunk_concat( const chunk_t c1, const chunk_t c2 )
+// {
+//     chunk_t cc;
+// 
+//     cc.len = c1.len + c2.len;
+//     if ((cc.ptr = malloc(cc.len)) != NULL) {
+//       memcpy(cc.ptr, c1.ptr, c1.len);
+//       memcpy(&(cc.ptr[c1.len]), c2.ptr, c2.len);
+//     }
+//     return cc;
+// }
+
+
+static bool
+skeyid_pke(struct state *st)
+{
+    /* This routine lifted straight from Kai Martius' patches */
+    /* and updated to use chunks */
+    struct hmac_ctx ctx;
+    union hash_ctx ictx;
+    const struct hash_desc *h = st->st_oakley.hasher;
+    u_char *nonce;
+    u_int16_t nonce_len;
+    chunk_t noncechunk, cky_i, cky_r;
+
+    nonce_len = h->hash_digest_len;
+    nonce=alloc_bytes(nonce_len, "nonce in skeyid_pke()");
+
+    h->hash_init(&ictx);
+    h->hash_update(&ictx, st->st_ni.ptr, st->st_ni.len);
+    h->hash_update(&ictx, st->st_nr.ptr, st->st_nr.len);
+    h->hash_final(nonce, &ictx);
+
+    setchunk(noncechunk, nonce, nonce_len);
+    setchunk(cky_i, st->st_icookie, COOKIE_SIZE);
+    setchunk(cky_r, st->st_rcookie, COOKIE_SIZE);
+
+    hmac_init_chunk(&ctx, h, noncechunk);
+    hmac_update_chunk(&ctx, cky_i);
+    hmac_update_chunk(&ctx, cky_r);
+    hmac_final_chunk(st->st_skeyid, "st_skeyid in skeyid_pke()", &ctx);
+
+    free(nonce);
+
+    return TRUE;
+}
+#endif
+
 
 /* Generate the SKEYID_* and new IV
  * See draft-ietf-ipsec-ike-01.txt 4.1
@@ -539,13 +709,21 @@
 
 	case OAKLEY_DSS_SIG:
 	    /* XXX */
-
+#ifdef OPENSSL
+	    if (!skeyid_digisig(st))
+	        return FALSE;
+	    break;
+#endif
 	case OAKLEY_RSA_ENC:
 	case OAKLEY_RSA_ENC_REV:
 	case OAKLEY_ELGAMAL_ENC:
 	case OAKLEY_ELGAMAL_ENC_REV:
 	    /* XXX */
-
+#ifdef OPENSSL
+	    if (!skeyid_pke(st))
+	        return FALSE;
+	    break;
+#endif
 	default:
 	    exit_log("generate_skeyids_iv(): unsupported authentication method %s",
 		enum_show(&oakley_auth_names, st->st_oakley.auth));
@@ -733,7 +911,7 @@
     return ctx.hmac_digest_len;
 }
 
-#if 0	/* only needed for DSS */
+#ifdef OPENSSL
 static void
 main_mode_sha1(struct state *st, u_char *hash_val, size_t *hash_len
 , bool hashi, bool hashus)
@@ -749,6 +927,7 @@
 }
 #endif
 
+
 /* Create an RSA signature of a hash.
  * Poorly specified in draft-ietf-ipsec-ike-01.txt 6.1.1.2.
  * Use PKCS#1 version 1.5 encryption of hash (called
@@ -936,6 +1115,13 @@
     switch (st->st_oakley.auth)
     {
     case OAKLEY_PRESHARED_KEY:
+#ifdef OPENSSL
+	case OAKLEY_RSA_ENC:
+	case OAKLEY_RSA_ENC_REV:
+	case OAKLEY_DSS_SIG:
+	case OAKLEY_ELGAMAL_ENC:
+	case OAKLEY_ELGAMAL_ENC_REV:
+#endif
 	{
 	    pb_stream *const hash_pbs = &md->chain[ISAKMP_NEXT_HASH]->pbs;
 
@@ -1041,7 +1227,8 @@
 	}
     }
 
-    DBG(DBG_CRYPT, DBG_log("encrypting using %s", enum_show(&oakley_enc_names, st->st_oakley.encrypt)));
+    DBG(DBG_CRYPT, DBG_log("encrypting using %s", 
+		enum_show(&oakley_enc_names, st->st_oakley.encrypt)));
 
     e->crypt(TRUE, enc_start, enc_len, st);
 
@@ -1721,6 +1908,9 @@
 
     pb_stream r_sa_pbs;
 
+	DBG(DBG_PARSING,
+	    DBG_log("in main_inI1_outR1");
+	);
     if (c == NULL)
     {
 	/* see if a wildcarded connection can be found */
@@ -1825,6 +2015,13 @@
 main_inR1_outI2(struct msg_digest *md)
 {
     struct state *const st = md->st;
+#ifdef OPENSSL
+    u_int8_t np;
+#endif
+
+	DBG(DBG_PARSING,
+	    DBG_log("in main_inR1_outI2");
+	);
 
     /* verify echoed SA */
     {
@@ -1834,12 +2031,19 @@
 	    , &sapd->payload.sa, NULL, TRUE, st));
     }
 
+// Here, we have to decide if the outgoing packet is going to be created 
+// for the classic RSASIG, or the OPENSSL functions.
+#ifdef OPENSSL
+if (!use_openssl(st->st_connection)) 
+{
+#endif
     /**************** build output packet HDR;KE;Ni ****************/
 
     /* HDR out.
      * We can't leave this to comm_handle() because the isa_np
      * depends on the type of Auth (eventually).
      */
+
     {
 	struct isakmp_hdr r_hdr = md->hdr;
 
@@ -1852,11 +2056,135 @@
     if (!build_and_ship_KE(st, &st->st_gi, st->st_oakley.group
     , &md->rbody, ISAKMP_NEXT_NONCE))
 	return STF_INTERNAL_ERROR;
-
+    
     /* Ni out */
     if (!build_and_ship_nonce(&st->st_ni, &md->rbody, ISAKMP_NEXT_NONE, "Ni"))
+      return STF_INTERNAL_ERROR;
+
+#ifdef OPENSSL
+}
+else /* use_openssl == TRUE */
+{
+
+	DBG(DBG_PARSING, 
+	    DBG_log("main_inR1_outI2: auth chosen is %s",
+			enum_show(&oakley_auth_names, st->st_oakley.auth));
+	);
+
+    if ((st->st_oakley.auth == OAKLEY_RSA_ENC_REV) ||
+	(st->st_oakley.auth == OAKLEY_ELGAMAL_ENC_REV)) {
+      struct isakmp_hdr r_hdr = md->hdr;
+
+      /* HDR out */
+      r_hdr.isa_np = ISAKMP_NEXT_NONCE;
+      if (!out_struct(&r_hdr, &isakmp_hdr_desc, &md->reply, &md->rbody))
+	return STF_INTERNAL_ERROR;
+      
+      if (!build_and_ship_nonce_pk(st, &st->st_ni, &md->rbody,
+				   ISAKMP_NEXT_KE, "<Ni_b>PubKey_r"))
+	return STF_INTERNAL_ERROR;
+
+      if (derive_symmetric_key(st, st->st_ni,
+			       st->st_icookie, COOKIE_SIZE,
+			       &st->st_ks_i,
+			       &st->st_ne_i) < 0) {
+	log("error while deriving symmetric key in revised mode");
+	return STF_INTERNAL_ERROR;
+	}
+	memset(st->st_ne_i_iv, 0, MAX_DIGEST_LEN);
+	DBG(DBG_PARSING,
+      DBG_dump_chunk("Generated Ke_i:", st->st_ne_i);
+	);
+
+      /* KE out */
+      if (!build_and_ship_KE_rpk(st, TRUE, &st->st_gi, st->st_oakley.group
+				 , &md->rbody, ISAKMP_NEXT_ID))
+	return STF_INTERNAL_ERROR;
+
+	/* <IDi1_b>Ke_i out */
+	{
+		chunk_t ch, out;
+	
+		// ch.len = st->st_myidentity.len + 4;
+		ch.len = sizeof(st->st_connection->this.id.ip_addr) + 4;
+		ch.ptr = alloc_bytes(ch.len, "encrypted identity");
+		// ch.ptr[0] = (u_int8_t)st->st_myidentity_type;
+		ch.ptr[0] = (u_int8_t)st->st_connection->this.id.kind;
+		memset(&(ch.ptr[1]), 0, 1);
+		memset(&(ch.ptr[2]), 0, 2);
+		// memcpy(&(ch.ptr[4]), st->st_myidentity.ptr, st->st_myidentity.len);
+		memcpy(&(ch.ptr[4]), &(st->st_connection->this.id.ip_addr), 
+			sizeof(st->st_connection->this.id.ip_addr));
+
+		if (!encrypt_payload(st, &st->st_ks_i, st->st_ne_i_iv,
+			ch, &out))
+			return STF_INTERNAL_ERROR;
+		freeanychunk(ch);
+		if (!out_generic_chunk(ISAKMP_NEXT_NONE, &isakmp_generic_desc,
+			&md->rbody, out, "my identity (ciphertext)")) 
+		{
+			freeanychunk(out);
+			return STF_INTERNAL_ERROR;
+		}
+		freeanychunk(out);
+	}
+
+    } else {
+      struct isakmp_hdr r_hdr = md->hdr;
+      
+      r_hdr.isa_np = ISAKMP_NEXT_KE;
+      if (!out_struct(&r_hdr, &isakmp_hdr_desc, &md->reply, &md->rbody))
 	return STF_INTERNAL_ERROR;
 
+      if ((st->st_oakley.auth == OAKLEY_RSA_ENC) ||
+	  (st->st_oakley.auth == OAKLEY_ELGAMAL_ENC))
+	np = ISAKMP_NEXT_ID;
+      else /* Digital Sig or Preshared key */
+	np = ISAKMP_NEXT_NONCE;
+      
+      /* KE out */
+      if (!build_and_ship_KE(st, &st->st_gi, st->st_oakley.group
+			     , &md->rbody, np))
+	return STF_INTERNAL_ERROR;
+      
+      if ((st->st_oakley.auth == OAKLEY_RSA_ENC) ||
+	  (st->st_oakley.auth == OAKLEY_ELGAMAL_ENC)) {
+	/* <IDii_b>PubKey_r out */
+	chunk_t ch;
+	
+	// ch.len = st->st_myidentity.len + 4;
+	ch.len = sizeof(st->st_connection->this.id.ip_addr) + 4;
+	ch.ptr = alloc_bytes(ch.len, "my identity (plaintext)");
+	/* Store the identity type */
+	// ch.ptr[0] = (u_int8_t)st->st_myidentity_type;
+	ch.ptr[0] = (u_int8_t)st->st_connection->this.id.kind;
+	memset(&(ch.ptr[1]), 0, 1); /* Set protoid to be 0 - perhaps it should be IPPROTO_UDP */
+	memset(&(ch.ptr[2]), 0, 2); /* Set the port to be 0 - perhaps it should be our_port */
+	// memcpy(&(ch.ptr[4]), st->st_myidentity.ptr, st->st_myidentity.len);
+	memcpy(&(ch.ptr[4]), &(st->st_connection->this.id.ip_addr), 
+		sizeof(st->st_connection->this.id.ip_addr));
+	/* PK encrypt this */
+	pubkey_encrypt_chunk( &ch, st );
+	if (!out_generic_chunk(ISAKMP_NEXT_NONCE, &isakmp_generic_desc,
+			       &md->rbody, ch, "my identity (ciphertext)"))
+	  return STF_INTERNAL_ERROR;
+	memset(ch.ptr, 0, ch.len);
+	freeanychunk(ch);
+
+	if (!build_and_ship_nonce_pk(st, &st->st_ni, &md->rbody,
+				     ISAKMP_NEXT_NONE, "<Ni_b>PubKey_r"))
+	  return STF_INTERNAL_ERROR;
+      } else {
+	DBG(DBG_PARSING,
+		DBG_log("Shipping nonce_i");
+	);
+	if (!build_and_ship_nonce(&st->st_ni, &md->rbody, ISAKMP_NEXT_NONE, "Ni"))
+	  return STF_INTERNAL_ERROR;
+      }
+    }
+}
+#endif
+
     /* finish message */
     close_message(&md->rbody);
 
@@ -1886,6 +2214,9 @@
     struct state *const st = md->st;
     pb_stream *keyex_pbs = &md->chain[ISAKMP_NEXT_KE]->pbs;
 
+	DBG(DBG_PARSING,
+	    DBG_log("in main_inI2_outR2");
+	);
     /* KE in */
     RETURN_STF_FAILURE(accept_KE(&st->st_gi, "Gi", st->st_oakley.group, keyex_pbs));
 
@@ -1927,6 +2258,191 @@
     return STF_REPLY;
 }
 
+#ifdef OPENSSL
+/* Handle HDR;KE;<IDii_b>PubKey_r;<Ni_b>PubKey_r from Initiator.
+ * Send a HDR;KE;<IDir_b>PubKey_i;<Nr_b>PubKey_i back.
+ */
+stf_status
+main_inI2_outR2_pk(struct msg_digest *md)
+{
+    struct state *const st = md->st;
+
+    pb_stream *keyex_pbs = &md->chain[ISAKMP_NEXT_KE]->pbs;
+
+	DBG(DBG_PARSING,
+	    DBG_log("in main_inI2_outR2_pk");
+	);
+    /* KE in */
+    // ACCEPT_KE(st->st_gi, "Gi", st->st_oakley.group, *keyex_pbs);
+	RETURN_STF_FAILURE(accept_KE(&st->st_gi, "Gi", 
+		st->st_oakley.group, keyex_pbs));
+
+    if (!decode_peer_id(md, FALSE))
+	return STF_FAIL + INVALID_ID_INFORMATION;
+
+    /* Ni_b<PubKey_r> in */
+    // ACCEPT_NONCE(st->st_ni, "<Ni_b>PubKey_r");
+    RETURN_STF_FAILURE(accept_nonce(md, &st->st_ni, "<Ni_b>PubKey_r"));
+
+    /** build output packet HDR;KE;<IDir_b>_PubKey_i;<Nr_b>PubKey_i*********/
+
+    /* HDR out done */
+
+    /* KE out */
+    if (!build_and_ship_KE(st, &st->st_gr, st->st_oakley.group
+    , &md->rbody, ISAKMP_NEXT_ID))
+	return STF_INTERNAL_ERROR;
+
+    {
+      /* <IDir_b>PubKey_i out */
+      chunk_t ch;
+      
+      // ch.len = st->st_myidentity.len + 4;
+	  ch.len = sizeof(st->st_connection->this.id.ip_addr) + 4;
+      ch.ptr = alloc_bytes(ch.len, "my identity (plaintext)");
+      /* Store the identity type */
+      // ch.ptr[0] = (u_int8_t)st->st_myidentity_type;
+	  ch.ptr[0] = (u_int8_t)st->st_connection->this.id.kind;
+      memset(&(ch.ptr[1]), 0, 1); /* Set protoid to be 0 - perhaps it should be IPPROTO_UDP */
+      memset(&(ch.ptr[2]), 0, 2); /* Set the port to be 0 - perhaps it should be our_port */
+      // memcpy(&(ch.ptr[4]), st->st_myidentity.ptr, st->st_myidentity.len);
+	  memcpy(&(ch.ptr[4]), &(st->st_connection->this.id.ip_addr), 
+		sizeof(st->st_connection->this.id.ip_addr));
+      /* PK encrypt this */
+      pubkey_encrypt_chunk( &ch, st );
+      if (!out_generic_chunk(ISAKMP_NEXT_NONCE, &isakmp_generic_desc, &md->rbody, ch, "my identity (ciphertext)"))
+	return STF_INTERNAL_ERROR;
+      memset(ch.ptr, 0, ch.len);
+      freeanychunk(ch);
+    }
+    
+    /* Nr out */
+    if (!build_and_ship_nonce_pk(st, &st->st_nr, &md->rbody, ISAKMP_NEXT_NONE, "<Nr_b>PubKey_i"))
+      return STF_INTERNAL_ERROR;
+
+    /* finish message */
+    close_message(&md->rbody);
+
+    /* next message will be encrypted, but not this one.
+     * We could defer this calculation.
+     */
+    compute_dh_shared(st, st->st_gi, st->st_oakley.group);
+#ifdef DODGE_DH_MISSING_ZERO_BUG
+    if (st->st_shared.ptr[0] == 0)
+	return STF_DROP_DOOMED_EXCHANGE;
+#endif
+    if (!generate_skeyids_iv(st))
+	return STF_FAIL + AUTHENTICATION_FAILED;
+    update_iv(st);
+
+    /* Advance state */
+    st->st_state = STATE_MAIN_R2;
+
+    return STF_REPLY;
+}
+#endif /* OPENSSL */
+
+#ifdef OPENSSL
+/* Handle HDR;<Ni_b>Pubkey_r;<KE_b>Ke_i;<IDi1_b>Ke_i from Initiator
+ * Send a HDR;<Nr_b>Pubkey_i;<KE_b>Ke_r;<IDr1_b>Ke_r back.
+ */
+stf_status
+main_inI2_outR2_rpk(struct msg_digest *md)
+{
+    struct state *const st = md->st;
+    pb_stream *keyex_pbs = &md->chain[ISAKMP_NEXT_KE]->pbs;
+
+	DBG(DBG_PARSING,
+		DBG_log("in main_inI2_outR2_rpk");
+	);
+
+    /* Ni_b<PubKey_r> in */
+    // ACCEPT_NONCE(st->st_ni, "<Ni_b>PubKey_r");
+    RETURN_STF_FAILURE(accept_nonce(md, &st->st_ni, "<Ni_b>PubKey_r"));
+
+    /* KE<Ke_r> in */
+    // ACCEPT_KE(st->st_gi, "Gi", st->st_oakley.group, *keyex_pbs);
+	RETURN_STF_FAILURE(accept_KE(&st->st_gi, "Gi", 
+		st->st_oakley.group, keyex_pbs));
+
+    if (!decode_peer_id(md, FALSE))
+	return STF_FAIL + INVALID_ID_INFORMATION;
+
+    /**************** build output packet ****************/
+
+    /* HDR out done */
+
+    /* Nr out */
+    if (!build_and_ship_nonce_pk(st, &st->st_nr, &md->rbody, ISAKMP_NEXT_KE, "<Nr_b>PubKey_i"))
+      return STF_INTERNAL_ERROR;
+
+    if (derive_symmetric_key(st, st->st_nr,
+			     st->st_rcookie, COOKIE_SIZE,
+			     &st->st_ks_r,
+			     &st->st_ne_r) < 0) {
+      log("error while deriving symmetric key in revised mode");
+      return STF_INTERNAL_ERROR;
+    }
+    memset(st->st_ne_r_iv, 0, MAX_DIGEST_LEN);
+
+	DBG(DBG_PARSING,
+	    DBG_dump_chunk("Generated Ke_r:", st->st_ne_r);
+	);
+
+    /* KE out */
+    if (!build_and_ship_KE_rpk(st, FALSE, &st->st_gr, st->st_oakley.group
+			       , &md->rbody, ISAKMP_NEXT_ID))
+      return STF_INTERNAL_ERROR;
+
+    /* <IDr1_b>Ke_r out */
+    {
+      chunk_t ch, out;
+      
+      // ch.len = st->st_myidentity.len + 4;
+	  ch.len = sizeof(st->st_connection->this.id.ip_addr) + 4;
+      ch.ptr = alloc_bytes(ch.len, "encrypted identity");
+      // ch.ptr[0] = (u_int8_t)st->st_myidentity_type;
+	  ch.ptr[0] = (u_int8_t)st->st_connection->this.id.kind;
+      memset(&(ch.ptr[1]), 0, 1);
+      memset(&(ch.ptr[2]), 0, 2);
+      // memcpy(&(ch.ptr[4]), st->st_myidentity.ptr, st->st_myidentity.len);
+	  memcpy(&(ch.ptr[4]), &(st->st_connection->this.id.ip_addr),
+		sizeof(st->st_connection->this.id.ip_addr));
+      if (!encrypt_payload(st, &st->st_ks_r, st->st_ne_r_iv,
+			   ch, &out))
+	return STF_INTERNAL_ERROR;
+      freeanychunk(ch);
+      if (!out_generic_chunk(ISAKMP_NEXT_NONE, &isakmp_generic_desc,
+			     &md->rbody, out, "my identity (ciphertext)")) {
+	freeanychunk(out);
+	return STF_INTERNAL_ERROR;
+      }
+      freeanychunk(out);
+    }
+    
+    /* finish message */
+    close_message(&md->rbody);
+
+    /* next message will be encrypted, but not this one.
+     * We could defer this calculation.
+     */
+    compute_dh_shared(st, st->st_gi, st->st_oakley.group);
+#ifdef DODGE_DH_MISSING_ZERO_BUG
+    if (st->st_shared.ptr[0] == 0)
+	return STF_DROP_DOOMED_EXCHANGE;
+#endif
+    if (!generate_skeyids_iv(st))
+	return STF_FAIL + AUTHENTICATION_FAILED;
+    update_iv(st);
+
+    /* Advance state */
+    st->st_state = STATE_MAIN_R2;
+
+    return STF_REPLY;
+}
+#endif /* OPENSSL */
+
+
 /* STATE_MAIN_I2:
  * SMF_PSK_AUTH: HDR, KE, Nr --> HDR*, IDi1, HASH_I
  * SMF_DS_AUTH: HDR, KE, Nr --> HDR*, IDi1, [ CERT, ] SIG_I
@@ -1941,12 +2457,22 @@
 main_inR2_outI3(struct msg_digest *md)
 {
     struct state *const st = md->st;
+#ifdef OPENSSL
+    struct connection *c = st->st_connection;
+#endif
+
     pb_stream *const keyex_pbs = &md->chain[ISAKMP_NEXT_KE]->pbs;
+
     int auth_payload = st->st_oakley.auth == OAKLEY_PRESHARED_KEY
 	? ISAKMP_NEXT_HASH : ISAKMP_NEXT_SIG;
 
+	DBG(DBG_PARSING,
+	    DBG_log("in main_inR2_outI3");
+	);
+
     /* KE in */
-    RETURN_STF_FAILURE(accept_KE(&st->st_gr, "Gr", st->st_oakley.group, keyex_pbs));
+    RETURN_STF_FAILURE(accept_KE(&st->st_gr, "Gr", 
+		st->st_oakley.group, keyex_pbs));
 
     /* Nr in */
     RETURN_STF_FAILURE(accept_nonce(md, &st->st_nr, "Nr"));
@@ -1962,7 +2488,6 @@
 	return STF_FAIL + AUTHENTICATION_FAILED;
 
     /*************** build output packet HDR*;IDii;HASH/SIG_I ***************/
-    /* ??? NOTE: this is almost the same as main_inI3_outR3's code */
 
     /* HDR* out done */
 
@@ -1972,16 +2497,144 @@
 	chunk_t id_b;
 	pb_stream id_pbs;
 
-	build_id_payload(&id_hd, &id_b, &st->st_connection->this);
+	build_id_payload(&id_hd, &id_b, &(st->st_connection->this));
+#ifdef OPENSSL
+if (use_openssl(st->st_connection)) 
+{
+  switch(st->st_oakley.auth) {
+  case OAKLEY_RSA_SIG:
+  case OAKLEY_DSS_SIG:
+    if ((c->cert_options & CERT_OPTION_SEND) == 0)
+      id_hd.isaiid_np = ISAKMP_NEXT_SIG;
+    else
+      id_hd.isaiid_np = ISAKMP_NEXT_CERT;
+    break;
+  case OAKLEY_RSA_ENC:
+  case OAKLEY_RSA_ENC_REV:
+    log("RSA method not supported yet");
+    return STF_INTERNAL_ERROR;
+    break;
+  default:
+    id_hd.isaiid_np = ISAKMP_NEXT_HASH;
+    break;
+  }
+}
+else
+{
+#endif /* OPENSSL */
 	id_hd.isaiid_np = auth_payload;
+#ifdef OPENSSL
+}
+#endif /* OPENSSL */
+
 	if (!out_struct(&id_hd, &isakmp_ipsec_identification_desc, &md->rbody, &id_pbs)
-	|| !out_chunk(id_b, &id_pbs, "my identity"))
-	    return STF_INTERNAL_ERROR;
+		|| !out_chunk(id_b, &id_pbs, "my identity")) 
+		return STF_INTERNAL_ERROR;
 	close_output_pbs(&id_pbs);
+    } /* IDii out done */
+
+#ifdef OPENSSL
+if (use_openssl(st->st_connection)) 
+{
+    if (((c->cert_options & CERT_OPTION_SEND) != 0) &&
+  ((st->st_oakley.auth == OAKLEY_RSA_SIG) ||
+   (st->st_oakley.auth == OAKLEY_DSS_SIG))) {
+      u_char *crt, *cx;
+      unsigned long ulen;
+      /* Send the signing certificate */
+
+      ulen = i2d_X509(c->cert, NULL);
+      ulen++;
+      if ((cx = alloc_bytes(ulen, "ASN.1 cert")) == NULL)
+  { return STF_INTERNAL_ERROR; }
+      cx[0] = (u_char)(CERT_TYPE_X509_SIG);
+      crt = &(cx[1]);
+      i2d_X509(c->cert, &crt);
+      if (!out_generic_raw(ISAKMP_NEXT_SIG, &isakmp_ipsec_certificate_desc
+             , &md->rbody, cx, ulen, "CERT_I"))
+  return STF_INTERNAL_ERROR;
+      pfree(cx);
     }
 
-    /* HASH_I or SIG_I out */
-    {
+  /* HASH_I out, OPENSSL */
+  {
+	u_char hash_val[MAX_DIGEST_LEN];
+	size_t hash_len = main_mode_hash(st, hash_val, TRUE, TRUE);
+    u_char *buf;
+    u_int elen;
+    bool ok;
+
+  /* Output the signature/hash as defined by the selected Oakley transform */
+
+  switch (st->st_oakley.auth) {
+  case OAKLEY_RSA_SIG: /* output signed HASH_I */
+    if ((buf = alloc_bytes(EVP_PKEY_size(c->key) + 32 /* bit of slack */,
+               "RSA signature")) == NULL)
+        return STF_INTERNAL_ERROR;
+    elen = RSA_private_encrypt(hash_len, hash_val, buf,
+                   ((EVP_PKEY *)(c->key))->pkey.rsa,
+                   RSA_PKCS1_PADDING);
+    if (!out_generic_raw(ISAKMP_NEXT_NONE, &isakmp_signature_desc, &md->rbody
+                 , buf, elen, "SIG_I"))
+      return STF_INTERNAL_ERROR;
+    pfree(buf);
+   
+	DBG(DBG_PARSING,
+	    DBG_log("Selected auth mechanism is %s",
+        	enum_show(&oakley_auth_names, st->st_oakley.auth));
+	)
+    break;
+
+  case OAKLEY_DSS_SIG:
+    /* We don't have to check whether the hash is a SHA1 */
+    /* one, since the ciphersuite offering DSA is only */
+    /* configured with SHA1. Don't change this configuration */
+    if (c->cert_options & CERT_OPTION_DSS_SHA)
+      main_mode_sha1(st, hash_val, &hash_len, TRUE, TRUE);
+
+    buf = alloc_bytes(EVP_PKEY_size(c->key) + 32 /* bit of slack */,
+              "DSA signature");
+    if (buf) {
+      ok = (c->cert_options & CERT_OPTION_DSS_ALT)
+        ? DSA_sign_raw(hash_val, hash_len,
+               buf, &elen, ((EVP_PKEY *)(c->key))->pkey.dsa)
+        : DSA_sign(EVP_PKEY_DSA, hash_val, hash_len,
+           buf, &elen, ((EVP_PKEY *)(c->key))->pkey.dsa);
+      if (!ok) {
+        /* DSA signing failed */
+        log_err();
+        return STF_INTERNAL_ERROR;
+      }
+      if (!out_generic_raw(ISAKMP_NEXT_NONE, &isakmp_signature_desc,
+               &md->rbody, buf, elen, "SIG_I"))
+        return STF_INTERNAL_ERROR;
+      pfree(buf);
+    } else
+      return STF_INTERNAL_ERROR;
+   
+	DBG(DBG_PARSING | DBG_CONTROL, 
+	    DBG_log("Selected auth mechanism is %s",
+			enum_show(&oakley_auth_names, st->st_oakley.auth));
+	);
+    break;
+    /* If we get to any of these, something has gone WAY wrong */
+  case OAKLEY_RSA_ENC:
+    return STF_INTERNAL_ERROR;
+  case OAKLEY_ELGAMAL_ENC:
+    return STF_INTERNAL_ERROR;
+  case OAKLEY_RSA_ENC_REV:
+    return STF_INTERNAL_ERROR;
+  case OAKLEY_ELGAMAL_ENC_REV:
+    return STF_INTERNAL_ERROR;
+  default:
+	} /* switch done */
+  } /* HASH_I out, openssl done. */
+}
+else
+{
+#endif /* OPENSSL */
+  /* HASH_I or SIG_I out, !OPENSSL */
+  {
 	u_char hash_val[MAX_DIGEST_LEN];
 	size_t hash_len = main_mode_hash(st, hash_val, TRUE, TRUE);
 
@@ -1996,8 +2649,8 @@
 	{
 	    /* SIG_I out */
 	    u_char sig_val[RSA_MAX_OCTETS];
-	    size_t sig_len = RSA_sign_hash(st->st_connection
-		, sig_val, hash_val, hash_len);
+	    size_t sig_len = RSA_sign_hash(st->st_connection, 
+			sig_val, hash_val, hash_len);
 
 	    if (sig_len == 0)
 	    {
@@ -2009,7 +2662,10 @@
 	    , &md->rbody, sig_val, sig_len, "SIG_I"))
 		return STF_INTERNAL_ERROR;
 	}
-    }
+  }
+#ifdef OPENSSL
+}
+#endif /* OPENSSL */
 
     /* encrypt message, except for fixed part of header */
 
@@ -2019,9 +2675,159 @@
 
     /* Advance state */
     st->st_state = STATE_MAIN_I3;
+    return STF_REPLY;
+}
+
+#ifdef OPENSSL
+/*
+ * Handle HDR;KE;<IDir_b>PubKey_i;<Nr_b>PubKey_i from responder.
+ * Send a HDR*;HASH_I back.
+ */
+stf_status main_inR2_outI3_pk(struct msg_digest *md)
+{
+    struct state *const st = md->st;
+    pb_stream *const keyex_pbs = &md->chain[ISAKMP_NEXT_KE]->pbs;
+
+	DBG(DBG_PARSING,
+	    DBG_log("in main_inR2_outI3_pk");
+	);
+
+    /* KE in */
+    // ACCEPT_KE(st->st_gr, "Gr", st->st_oakley.group, *keyex_pbs);
+	RETURN_STF_FAILURE(accept_KE(&st->st_gr, "Gr", 
+		st->st_oakley.group, keyex_pbs));
+
+    /* IDir in */
+    if (!decode_peer_id(md, TRUE))
+    return STF_FAIL + INVALID_ID_INFORMATION;
+
+    /* Nr in */
+    // ACCEPT_NONCE(st->st_nr, "<Nr_b>PubKey_i");
+    RETURN_STF_FAILURE(accept_nonce(md, &st->st_nr, "<Nr_b>PubKey_i"));
+
+    /* done parsing; initialize crypto  */
+
+    compute_dh_shared(st, st->st_gr, st->st_oakley.group);
+#ifdef DODGE_DH_MISSING_ZERO_BUG
+    if (st->st_shared.ptr[0] == 0)
+    return STF_REPLACE_DOOMED_EXCHANGE;
+#endif
+    if (!generate_skeyids_iv(st))
+    return STF_FAIL + AUTHENTICATION_FAILED;
+
+    /**************** build output packet HDR*;HASH_I ****************/
+
+    /* HDR* out done */
+
+    /* HASH_I out */
+    {
+  u_char hash_val[MAX_DIGEST_LEN];
+  size_t hash_len = main_mode_hash(st, hash_val, TRUE, TRUE);
+
+  // size_t hash_len;
+  // main_mode_hash(st, hash_val, &hash_len, TRUE, TRUE);
+
+  if (!out_generic_raw(ISAKMP_NEXT_NONE, &isakmp_hash_desc, &md->rbody
+  , hash_val, hash_len, "HASH_I"))
+      return STF_INTERNAL_ERROR;
+    }
+
+    /* encrypt message, except for fixed part of header */
+
+    /* st_new_iv was computed by generate_skeyids_iv */
+    if (!encrypt_message(&md->rbody, st))
+    return STF_INTERNAL_ERROR;  /* ??? we may be partly committed */
+
+    /* Advance state */
+    st->st_state = STATE_MAIN_I3;
 
     return STF_REPLY;
 }
+#endif /* OPENSSL */
+
+#ifdef OPENSSL
+/* Handle HDR;KE;<Nr_b>PubKey_i;<KE_b>Ke_r;<IDr1_b>Ke_r from responder.
+ * Send a HDR*;HASH_I back.
+ */
+stf_status
+main_inR2_outI3_rpk(struct msg_digest *md)
+{
+    struct state *const st = md->st;
+    pb_stream *const keyex_pbs = &md->chain[ISAKMP_NEXT_KE]->pbs;
+
+	DBG(DBG_PARSING,
+	    DBG_log("in main_inR2_outI3_rpk");
+	);
+
+    /* Nr in */
+    // ACCEPT_NONCE(st->st_nr, "<Nr_b>PubKey_i");
+    RETURN_STF_FAILURE(accept_nonce(md, &st->st_nr, "<Nr_b>PubKey_i"));
+
+    /* KE in */
+    // ACCEPT_KE(st->st_gr, "Gr", st->st_oakley.group, *keyex_pbs);
+	RETURN_STF_FAILURE(accept_KE(&st->st_gr, "Gr", 
+		st->st_oakley.group, keyex_pbs));
+
+    /* IDir in */
+    if (!decode_peer_id(md, TRUE))
+  return STF_FAIL + INVALID_ID_INFORMATION;
+
+    /* done parsing; initialize crypto  */
+
+    compute_dh_shared(st, st->st_gr, st->st_oakley.group);
+#ifdef DODGE_DH_MISSING_ZERO_BUG
+    if (st->st_shared.ptr[0] == 0)
+  return STF_REPLACE_DOOMED_EXCHANGE;
+#endif
+    if (!generate_skeyids_iv(st))
+  return STF_FAIL + AUTHENTICATION_FAILED;
+
+    /**************** build output packet HDR*;HASH_I ****************/
+
+    /* HDR* out done */
+
+    /* HASH_I out */
+    {
+  u_char hash_val[MAX_DIGEST_LEN];
+
+  // size_t hash_len;
+  // main_mode_hash(st, hash_val, &hash_len, TRUE, TRUE);
+  size_t hash_len = main_mode_hash(st, hash_val, TRUE, TRUE);
+
+  if (!out_generic_raw(ISAKMP_NEXT_NONE, &isakmp_hash_desc, &md->rbody
+  , hash_val, hash_len, "HASH_I"))
+      return STF_INTERNAL_ERROR;
+    }
+
+    /* encrypt message, except for fixed part of header */
+
+    /* st_new_iv was computed by generate_skeyids_iv */
+    if (!encrypt_message(&md->rbody, st))
+    return STF_INTERNAL_ERROR;  /* ??? we may be partly committed */
+
+    /* Advance state */
+    st->st_state = STATE_MAIN_I3;
+
+    return STF_REPLY;
+}
+#endif /* OPENSSL */
+
+
+#ifdef OPENSSL
+/* STATE_MAIN_R2:
+ * Which type of DS are we currently handling?
+ * Classic? OPENSSL?
+ */
+stf_status
+main_inI3_outR3_whichds(struct msg_digest *md)
+{ 
+	if (! use_openssl(md->st->st_connection)) {
+		return main_inI3_outR3(md);
+	} else {
+		return main_inI3_outR3_ds(md);
+	}
+}
+#endif /* OPENSSL */
 
 /* STATE_MAIN_R2:
  * PSK_AUTH: HDR*, IDi1, HASH_I --> HDR*, IDr1, HASH_R
@@ -2030,11 +2836,16 @@
  */
 stf_status
 main_inI3_outR3(struct msg_digest *md)
-{
+{ 
     struct state *const st = md->st;
+
     int auth_payload = st->st_oakley.auth == OAKLEY_PRESHARED_KEY
 	? ISAKMP_NEXT_HASH : ISAKMP_NEXT_SIG;
 
+	DBG(DBG_PARSING,
+	    DBG_log("in main_inI3_outR3");
+	);
+
     /* input code similar to main_inR3 -- should be factored */
 
     /* IDii in */
